!function (doc, html, $) {
  // A bunch of this code is borrowed from Qwery so Sizzle acts as a drop-in replacement
  // and can handle the same argument types for $() as Qwery.
  // Similar code can be found in NWMatcher's bridge
  var sizzle = require('sizzle')
    , isNode = function (el, t) {
        return el && typeof el === 'object' && (t = el.nodeType) && (t == 1 || t == 9)
      }
    , arrayLike = function (o) {
        return (typeof o === 'object' && isFinite(o.length))
      }
    , flatten = function (ar) {
        for (var r = [], i = 0, l = ar.length; i < l; ++i) arrayLike(ar[i]) ? (r = r.concat(ar[i])) : (r[r.length] = ar[i])
        return r
      }
    , uniq = function (ar) {
        var a = [], i, j
        o: for (i = 0; i < ar.length; ++i) {
          for (j = 0; j < a.length; ++j) {
            if (a[j] == ar[i]) continue o
          }
          a[a.length] = ar[i]
        }
        return a
      }
    , normalizeRoot = function (root) {
        if (!root) return doc
        if (typeof root == 'string') return sizzle(root)[0]
        if (!root.nodeType && arrayLike(root)) return root[0]
        return root
      }
    , isAncestor = 'compareDocumentPosition' in html ?
        function (element, container) {
          return (container.compareDocumentPosition(element) & 16) == 16
        } : 'contains' in html ?
        function (element, container) {
          container = container.nodeType === 9 || container == window ? html : container
          return container !== element && container.contains(element)
        } :
        function (element, container) {
          while (element = element.parentNode) if (element === container) return 1
          return 0
        }
    , select = function (selector, _root) {
        var root = normalizeRoot(_root)
        if (!root || !selector) return []
        if (selector === window || isNode(selector)) {
          return !_root || (selector !== window && isNode(root) && isAncestor(root, container)) ? [selector] : []
        }
        if (selector && arrayLike(selector)) return flatten(selector)
        return sizzle(selector, root)
      }
    , is = function (s) {
        var i, l
        for (i = 0, l = this.length; i < l; i++) {
          if (sizzle.matchesSelector(this[i], s))
            return true
        }
        return false
      }

  $._select = function (selector, root) {
    // if 'bonzo' is available at run-time use it for <element> creation
    return ($._select = (function(bonzo) {
      try {
        bonzo = require('bonzo')
        return function (selector, root) {
          return /^\s*</.test(selector) ? bonzo.create(selector, root) : select(selector, root)
        }
      } catch (e) { }
      return select
    })())(selector, root)
  }

  $.ender({
      // boolean, does at least one element in the collection match the given selector
      is: is
    , matchesSelector: is
      // find all elements that are children of the elements in this collection matching
      // the given selector
    , find: function (s) {
        var r = [], i = 0, l = this.length
        for (; i < l; i++)
          r = r.concat(select(s, this[i]))
        return $(uniq(r))
      }
      // add additional elements to this collection matching the given selector
    , and: function (s, r) {
        var plus = select(s, r)
          , i = this.length
          , l = this.length + plus.length
          , j = 0
        for (; i < l; i++, j++)
          this[i] = plus[j]
        return $(uniq(this))
      }
  }, true)

}(document, document.documentElement, ender)
